import java.io.*;
import java.util.zip.*;
/**
 * A class compress a string
 *
 * @version	0.1 Feb 19, 2003
 * @author 	Zheyuan Yu
**/

public class IRZIP {
	public static String compress( String s ) {
		Deflater defl = new Deflater( Deflater.BEST_COMPRESSION );
		defl.setInput( s.getBytes() );
		defl.finish();
		boolean done = false;
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		while (!done) {
			byte[] buf = new byte[256];
			int bufnum = defl.deflate( buf );
			bos.write( buf, 0, bufnum );
			if ( bufnum < buf.length )
			done = true;
		}
		try {
			bos.flush();
			bos.close();
		}
		catch(IOException ioe) {
		}
		return( new String(bos.toByteArray()) );
    }

    public static String uncompress( String s ) {
    	byte[] b=s.getBytes();
    	Inflater infl = new Inflater();
    	infl.setInput( b );
    	StringBuffer retval = new StringBuffer();
    	boolean done = false;
    	while (!done) {
    		byte[] buf = new byte[256];
    		try {
    			int bufnum = infl.inflate( buf );
    			retval.append( new String( buf, 0, bufnum ) );
    			if ( bufnum < buf.length )
    			    done = true;
    		}
    		catch( DataFormatException dfe ) {
    			done = true;
    		}
        }
        return(retval.toString());
    }

}

/*class IRZIP {
	 Buffer is used to improve the performance of I/O,
	   //BUFF_SIZE is the default size of Buffer
	static final int BUFF_SIZE = 1000000;

	public IRZIP () throws IOException {
	}

	static public String compress (String s) throws IOException {
		// compress the string s
        byte[] input = s.getBytes("ISO-8859-1");

        // Create the compressor with highest level of compression
        Deflater compressor = new Deflater();
        compressor.setLevel(Deflater.BEST_COMPRESSION);

        //Give the compressor the data to compress
        compressor.setInput(input);
        compressor.finish();

        // Create an expandable byte array to hold the compressed data.
        //   You cannot use an array that's the same size as the orginal because
        //   there is no guarantee that the compressed data will be smaller than
        //   the uncompressed data.

        ByteArrayOutputStream bos = new ByteArrayOutputStream(input.length+512);

        // Compress the data
        byte[] buf = new byte[input.length+512];

        while (!compressor.finished()) {
        	int count = compressor.deflate(buf);
        	bos.write(buf, 0, count);
        }
        try {
        	bos.close();
        }
        catch (IOException e) {
        }
        //Get the compressed data
        byte[] compressedData = bos.toByteArray();

        String strResult=new String(compressedData);

        return (strResult);
    }

   	static public String uncompress (String s) throws IOException {

   		// decompress
   		// Create the decompressor and give it the data to compress
   		byte[] compressedData = s.getBytes("ISO-8859-1");
        byte[] buf;
   		Inflater decompressor = new Inflater();
   		decompressor.setInput(compressedData);
   		//Create an expandable byte array to hold the decompressed data
   		//   ByteArrayOutputStream
        ByteArrayOutputStream bos = new ByteArrayOutputStream(BUFF_SIZE);
        // Decompress the data
        buf = new byte[BUFF_SIZE];
        while (!decompressor.finished()) {
        	try {
        		int count = decompressor.inflate(buf);
        		bos.write(buf, 0, count);
        	}
        	catch (DataFormatException e) {
        		System.out.println("Decompress data format exception");
            }
        }
        try {
        	bos.close();
        }
        catch (IOException e) {

        }
        // Get the decompressed data
        byte[] decompressedData = bos.toByteArray();
        String strResult=new String(decompressedData);
        //System.out.println("Compressed string:");
        //System.out.println(strResult);
        //System.in.read();
        return (strResult);
    }
}
*/