import java.io.*;
import java.util.*;
import java.util.zip.*;
import au.com.pharos.test.Test;
import au.com.pharos.packing.Packing;
import au.com.pharos.packing.StringPacking;
import au.com.pharos.packing.RawPacking;
import au.com.pharos.gdbm.*;
import IRUtilities.Porter;
public class Search{
   	/* Parameter to define source text file */
    private String strRepositoryFile="/users/grad/zyu/6403/Repository";
    private String strIndexFile="/users/grad/zyu/6403/index";
    private String strVectorFile="/users/grad/zyu/6403/vector";
    //private String strWeightFile="/users/grad/zyu/6403/weight";
    private String strWeightFile="/users/grad/zyu/6403/weight";
    private Hit h;
    private GdbmFile indexDatabase = null, repositoryDatabase = null,vectorDatabase=null,weightDatabase=null;
    public Map SearchResult, mapKeyword, sortedSearchResult;
	private Porter st;

    /*public static void main(String[] args){

    	try	{
    		String strKeyword="Find me stories about natural disasters like earthquakes";
    		Map mapKeyword=new TreeMap();
    		Search s=new Search();
    		mapKeyword=s.KeyWord(strKeyword);
        	//Set mappings = mapKeyword.entrySet();
        	//iterate through mappings and print content
	        for (Iterator i = mappings.iterator(); i.hasNext();) {
	            Map.Entry me = (Map.Entry)i.next();
    		    String strKey=(String)me.getKey();
    		    //System.out.println(strKey);
    		}
    		//Vector hitsetVector=s.HitSet("halifax");
    		//System.out.println(hitsetVector.size());
    		s.AndSearch(mapKeyword);
    	    Set mappings = s.SearchResult.entrySet();
	        //iterate through mappings and print content
	        int intCount=0;
	        System.out.println("\nSearching result:");
	        for (Iterator i = mappings.iterator(); i.hasNext();) {
	        	Map.Entry me = (Map.Entry)i.next();
	        	Integer IntDocID = (Integer)me.getKey();
	        	//I=(lexiconEntry)me.getValue();
	            intCount++;     //nhits: number of hits
	            String strDoc=s.getDoc(IntDocID.intValue());
	            System.out.println(s.getTitle(strDoc));
	           // System.out.println(s.getContent(strDoc));
	            //System.out.println(s.getCategory(strDoc));
	            //System.in.read();
	            //System.in.read();
	         }
	         System.out.println("\ntotal results: "+intCount);

    		s.ClearAll();
    	}

    	catch (Exception e) {
    		System.out.println("Error: " + e.getMessage());
    	}
    	finally {
    	}
    }
    */
    public Search() throws IOException {
        indexDatabase=new GdbmFile(strIndexFile, GdbmFile.READER);
	    //Test.ok(1, indexDatabase != null);
	    repositoryDatabase=new GdbmFile(strRepositoryFile, GdbmFile.READER);
	    //Test.ok(2, repositoryDatabase!=null);
	    vectorDatabase=new GdbmFile(strVectorFile,GdbmFile.READER);
	    weightDatabase=new GdbmFile(strWeightFile,GdbmFile.READER);
   	    /* Set the packing strategy*/
        indexDatabase.setKeyPacking(new StringPacking());
        indexDatabase.setValuePacking(new StringPacking());
        repositoryDatabase.setKeyPacking(new StringPacking());
        repositoryDatabase.setValuePacking(new StringPacking());
        vectorDatabase.setKeyPacking(new StringPacking());
        vectorDatabase.setValuePacking(new StringPacking());
        weightDatabase.setKeyPacking(new StringPacking());
        weightDatabase.setValuePacking(new StringPacking());

        //Comparator comparator = new Comparator();

        SearchResult=new HashMap();
        sortedSearchResult=new TreeMap(new Comparator() {
	   		public int compare(Object o1, Object o2) {
        			// these will be string key objects paras
        			// value has to be Comparable
        			//String key1 = (String)o1;//key1
        			//String key2 = (String)o2;//key2
        			//String value1 = (String)(myHashMap.get(o1));//value1
        			//String value2 = (String)(myHashMap.get(o2));//value2
        			int intKey1=((Integer)o1).intValue(); //key1
        			int intKey2=((Integer)o2).intValue();//key2
        			double value1=((Double)(SearchResult.get(o1))).doubleValue();
        			double value2=((Double)(SearchResult.get(o2))).doubleValue();
        			int intReturn=0;
        			//sort on key as well if the value is different
        			if(value1==value2) {
        				intReturn=-1;
        			} else {
        				if (value1<value2) {
        					//System.out.println("value1 "+value1+" <"+" value2 "+value2);
        					intReturn=1; //value1>value2
        			    }
        			    else {
        			    	intReturn=-1; //value1<value2
        					//System.out.println("value1 "+value1+" >"+" value2 "+value2);


        			    }
        			}
       				return (intReturn);
    	        }
        });
        mapKeyword=new HashMap();
        st = new Porter ();
   }
    public void ClearAll() throws IOException {
         if(indexDatabase !=null)
             indexDatabase.close();
         if(repositoryDatabase !=null)
             repositoryDatabase.close();
         if (vectorDatabase!=null)
             vectorDatabase.close();
	     if (weightDatabase!=null)
	         weightDatabase.close();

    }
    public String getTerm (String strNo){
    	String strTermCodeFile="/users/grad/zyu/6403/termcode";
    	try {
    	    GdbmFile termcodeDatabase=new GdbmFile(strTermCodeFile,GdbmFile.READER);
    	    /* Set the packing strategy*/
            termcodeDatabase.setKeyPacking(new StringPacking());
            termcodeDatabase.setValuePacking(new StringPacking());
    	    Enumeration keys = termcodeDatabase.keys();
    	    while (keys.hasMoreElements()) {
    	    	String strTerm = (String) keys.nextElement();
                String strData = (String) termcodeDatabase.fetch(strTerm);
	            int intNo=new java.math.BigInteger(strData.getBytes()).intValue();
                //System.out.println(strTerm+" "+intNo);

                //if (compare(strNo.getBytes(),strData.getBytes())==0){
                if (strData.compareTo(strNo)==0) {
                	return strTerm;
                }
            }
        }
        catch (Exception e) {
        	System.out.println("Error getTerm "+e.getMessage());
        }
        return "";
    }

    public Vector getSearchResult (String strSearchType){
    	Vector v=new Vector();
    	try {
    	    Set mappings;

  	        if ((strSearchType.compareTo("AND")==0)||(strSearchType.compareTo("OR")==0)){
  	        	mappings=SearchResult.entrySet();

  	        }
  	        else {
  	        	mappings=sortedSearchResult.entrySet();
  	        }
    	    //iterate through mappings and print content
	        for (Iterator i = mappings.iterator(); i.hasNext();) {
    	        Map.Entry resultEntry = (Map.Entry)i.next();
        		Integer IntDocID=(Integer)resultEntry.getKey();
        		v.add(IntDocID);
        	}
        }
        catch (Exception e) {
        	System.out.println("Error getTerm "+e.getMessage());
        }
        return v;
    }



    public String KeyWord (String strKeyWord) {
        //Map mapKeyword = new TreeMap();
        String strKeywordUsed="";
        mapKeyword.clear();
        try {
        	Porter p;
		    StopWord stop=new StopWord();
            StringTokenizer st = new StringTokenizer(strKeyWord);
            String strKeyToken="";
            String strDBFile="/users/grad/zyu/6403/termcode";
   	    	GdbmFile termcodeDatabase = new GdbmFile(strDBFile, GdbmFile.READER);
	    	termcodeDatabase.setKeyPacking(new StringPacking());
	    	termcodeDatabase.setValuePacking(new StringPacking());
            while (st.hasMoreTokens()) {
            	strKeyToken=st.nextToken();
            	if (stop.IsStopWord(strKeyToken.getBytes()))
            	    continue;
            	strKeyToken=Stemming(strKeyToken);
            	String strNo="";
            	if (!(termcodeDatabase.exists(strKeyToken)))
            	    continue;
           		strNo=(String) termcodeDatabase.fetch(strKeyToken);
            	strKeywordUsed+=strKeyToken+" ";
            	mapKeyword.put(strNo,new Double(0.0));
            }
        }
        catch( Exception e ) {
         	System.out.println( "Error KeyWord "+ strKeyWord +e.getMessage());
        }
        return strKeywordUsed;
    }

    public void VectorSearch(double dblThreshold){
    	try {
   	        SearchResult.clear();
    	    String strKeyword="";
    	    Set mappings = mapKeyword.entrySet();
    	    //Map mapVector;
    	    Set setKeyword = mapKeyword.entrySet();
    	    //iterate through mappings and print content
	        for (Iterator i = mappings.iterator(); i.hasNext();) {
    	        Map.Entry keywordEntry = (Map.Entry)i.next();
        		strKeyword=(String)keywordEntry.getKey();
    	    	Vector v=HitSet(strKeyword);
    		    int intHitSize=v.size();
    		    for(int j=0; j<intHitSize;j++){
    		    	int intCount=0;
        	        int intDocumentFrequency=0;
    	    	    //process forward index vector for each doc in the hit set
	        	    //docuent id of the document in the hit set.
	         	    int intDocID = ((Integer)v.elementAt(j)).intValue();
	                //get the hits for the document from vector file
	                String strVector=getWeightVector(intDocID);
     	        	// iterate through the hits of the document
         	        double dblWeight=0.0,dblSumWeight=0.0,dblSumQueryWeightSquare=0.0;//,dblSumWeightSquare=0.0,
     	            int intTotalQueryInDocument=0;
    	            for (Iterator k = setKeyword.iterator(); k.hasNext();) {
	        	        Map.Entry ke = (Map.Entry)k.next();
	        	        strKeyword = (String)ke.getKey(); //word
        	    	    dblWeight=getWeight(strKeyword,strVector);
        	    	    if (dblWeight>0) {
   	     	                dblSumWeight+=dblWeight;
     	     	            intTotalQueryInDocument++;
   	     	            //if (intDocID==1864) {
            	          //  int intNo=new java.math.BigInteger(strKeyword.getBytes()).intValue();
   	     	            	//System.out.println("Finding: "+intNo+", "+getTerm(strKeyword));
   	     	            	//System.out.println(dblWeight);

   	     	            //}

   	     	            }
   	     	            dblSumQueryWeightSquare+=1.0*1.0;
     	            }
     	            double dblRelevance=dblSumWeight/java.lang.Math.sqrt(dblSumQueryWeightSquare);//+(double)intTotalQueryInDocument;
     	            //dblRelevance=dblRelevance+(double)intTotalQueryInDocument*1;
     	            if (dblRelevance>=dblThreshold) {
     	        	    Double DBLRelevance=new Double(dblRelevance);
     	                SearchResult.put(new Integer(intDocID),DBLRelevance);
     	            }
    		    }
    	    }

	        sortedSearchResult.clear();
            sortedSearchResult.putAll(SearchResult);
        }
        catch (Exception e) {
        	System.out.println("Error VectorSearch "+e.getMessage());
        }


     }

    public void OrSearch(){
    	try {
   	        SearchResult.clear();
    	    String strKeyword="";
    	    Integer intDocID;
    	    Set mappings = mapKeyword.entrySet();
    	    //iterate through mappings and print content
	        for (Iterator i = mappings.iterator(); i.hasNext();) {
    	        Map.Entry me = (Map.Entry)i.next();
        		strKeyword=(String)me.getKey();
    	    	Vector v=HitSet(strKeyword);
    		    int intHitSize=v.size();
    		    for(int j=0; j<intHitSize;j++){
    			    SearchResult.put((Integer)v.elementAt(j),new Double(0.0));
    		    }
    	    }
        }
        catch (Exception e) {
        	System.out.println("Error OrSearch "+e.getMessage());
        }
    }

    public void AndSearch(){
    	try {
    		Map tempTreeMap=new TreeMap();
    		SearchResult.clear();
    		String strKeyword="";
    		Integer intDocID;
    		int intCount=0;
    		//for(int i=0;i<intSize;i++) {
        	Set mappings = mapKeyword.entrySet();
        	//iterate through mappings and print content
	        for (Iterator i = mappings.iterator(); i.hasNext();) {
	            Map.Entry me = (Map.Entry)i.next();
    		    strKeyword=(String)me.getKey();
    		    Vector v=HitSet(strKeyword);
    		    int intHitSize=v.size();
    		    if (intHitSize<=0){
    		    	SearchResult.clear();
    		    	return;
    		    }
        		if (intCount==0) {  // first keyword
        			for(int j=0; j<intHitSize;j++){
       		    	    intDocID=(Integer)v.elementAt(j);
        				SearchResult.put(intDocID,new Double(0.0));
        			}

        		}
        		else{
        			for(int j=0; j<intHitSize;j++){
       		    	    intDocID=(Integer)v.elementAt(j);
            		    if (SearchResult.containsKey(intDocID)) {
            			    tempTreeMap.put(intDocID, new Double(0.0));
            			}
            		}
     		        SearchResult.clear();
    		        SearchResult.putAll((Map)tempTreeMap);
    		        tempTreeMap.clear();
    		    }
    		    intCount++;
    		}
      	}

        catch (Exception e) {
        	System.err.println("Error OrSearch "+e.getMessage());
        }
    }
    public Vector HitSet(String strKeyword) {
    	Vector v= new Vector();
    	String strHitSet="";
    	try {
    		//if (indexDatabase.exists(strKeyword))
	        strHitSet = (String) indexDatabase.fetch(strKeyword);
	        if (strHitSet!=null) {
	           byte[] byteDocCount=new byte[2];
       		   byte[] byteHitSet=strHitSet.getBytes();
       		   byteDocCount[0]=byteHitSet[0];
       		   byteDocCount[1]=byteHitSet[1];
               int intDocCount=new java.math.BigInteger(byteDocCount).intValue();
    		   for (int i=0; i<intDocCount;i++) {
		           byte[] byteDocID=new byte[2];
		     	   byteDocID[0]=byteHitSet[i*2+2];
		     	   byteDocID[1]=byteHitSet[i*2+1+2];
		     	   int intDocID=new java.math.BigInteger(byteDocID).intValue();
		     	   v.addElement(new Integer(intDocID));
    		   }
         	}
         }
	     catch (Exception e) {
	         v.clear();
	     }
         return v;
     }
    public String getDoc(int intDocID) {
    	IRZIP zip=new IRZIP();
    	String strDoc="";
    	try {
		    strDoc =zip.uncompress((String) repositoryDatabase.fetch(Integer.toString(intDocID)));
		}
		catch (Exception e) {
			System.out.println("Error getDoc "+intDocID+" "+e.getMessage());
	    }
	    return strDoc;

	 }
	 public String getTitle(int intDocID) {
	 	return getTitle(getDoc(intDocID));
	 }
	 public String getTitle(String strDoc){
	 	int intLen=strDoc.length();
	 	String strTitle="Title not found";
	 	try {
	 		int intStart=strDoc.indexOf("<HEADLINE>")+10;
	 		int intEnd=strDoc.indexOf("</HEADLINE>")-1;
	 		if ((intStart<0)||(intEnd<0)) {
	 			intStart=strDoc.indexOf("<CAPHEAD>")+9;
	 			intEnd=strDoc.indexOf("</CAPHEAD>")-1;
	 			if ((intStart<0)||(intEnd<0)) {
	 				strTitle="Title not found";
	 			}
	 			else{
    		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	    			strTitle=new String (byteDoc,intStart,intEnd-intStart+1);
	 			}
	 		}
	 		else {
	 		  //  System.out.println("intStart"+intStart+" intEnd "+intEnd+" strDoc length"+strDoc.length());
		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	 			strTitle=new String (byteDoc,intStart,intEnd-intStart+1);
	 		}


	 	}
	 	catch (Exception e) {
	 		System.out.println("Error getTitle "+e.getMessage()+"\n"+strDoc);
	 	}
	 	return strTitle;
	 }

 	 public String getContent(String strDoc){
	 	String strContent="";
	 	try {
	 		int intStart=strDoc.indexOf("<CONTENT>")+9;
	 		int intEnd=strDoc.indexOf("</CONTENT>")-1;
	 		if ((intStart<0)||(intEnd<0)) {
     			intStart=strDoc.indexOf("<CAPTION>")+9;
	 			intEnd=strDoc.indexOf("</CAPTION>")-1;
	 			if ((intStart<0)||(intEnd<0)) {
	 				strContent="Content not found";
	 			}
	 			else{
    		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	    			strContent=new String (byteDoc,intStart,intEnd-intStart+1);
	 			}
	 		}
	 		else {
		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	 			strContent=new String (byteDoc,intStart,intEnd-intStart+1);
	 		}

	 	}
	 	catch (Exception e) {
	 		System.out.println("Error getContent "+e.getMessage());
	 	}
	 	return strContent;
	 }

 	 public String getCategory(String strDoc){
	 	String strCategory="";
	 	try {
	 		int intStart=strDoc.indexOf("<CATEGORY>")+10;
	 		int intEnd=strDoc.indexOf("</CATEGORY>")-1;
	 		if ((intStart<0)||(intEnd<0)) {
	 		}
	 		else {
		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	 			strCategory=new String (byteDoc,intStart,intEnd-intStart+1);
	 		}
	 	}
	 	catch (Exception e) {
	 		System.out.println("Error getCategory "+e.getMessage());
	 	}
	 	return strCategory;
	 }

  	 public String getPhotos(String strDoc){
	 	String strResult="";
	 	try {
	 		int intStart=strDoc.indexOf("<PHOTOS>")+8;
	 		int intEnd=strDoc.indexOf("</PHOTOS>")-1;
	 		if ((intStart<0)||(intEnd<0)) {
	 		}
	 		else {
		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	 			strResult=new String (byteDoc,intStart,intEnd-intStart+1);
	 		}
	 	}
	 	catch (Exception e) {
	 		System.out.println("Error getPhotos "+e.getMessage());
	 	}
	 	return strResult;
	 }

  	 public String getByGraph(String strDoc){
	 	String strResult="";
	 	try {
	 		int intStart=strDoc.indexOf("<BYGRAPH>")+9;
	 		int intEnd=strDoc.indexOf("</BYGRAPH>")-1;
	 		if ((intStart<0)||(intEnd<0)) {
	 		}
	 		else {
		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	 			strResult=new String (byteDoc,intStart,intEnd-intStart+1);
	 		}
	 	}
	 	catch (Exception e) {
	 		System.out.println("Error getByGraph "+e.getMessage());
	 	}
	 	return strResult;
	 }
  	 public String getCaption(String strDoc){
	 	String strResult="";
	 	try {
	 		int intStart=strDoc.indexOf("<CAPTION>")+9;
	 		int intEnd=strDoc.indexOf("</CAPTION>")-1;
	 		if ((intStart<0)||(intEnd<0)) {
	 		}
	 		else {
		        byte [] byteDoc=strDoc.getBytes("ISO-8859-1");
	 			strResult=new String (byteDoc,intStart,intEnd-intStart+1);
	 		}
	 	}
	 	catch (Exception e) {
	 		System.out.println("Error getCaption "+e.getMessage());
	 	}
	 	return strResult;
	 }



	 public String getAbstract(String strContent, String strKeywordUsed) {
	 	String s=strContent.toLowerCase();
	 	String strReturn="";
	 	int intLen=strContent.length();
	 	int intEnd=0;
	 	int intIndex=0;
	 	int intStart=0;
	 	int intTokenLen=0;
	 	try {
    	    byte[] byteContent=s.getBytes("ISO-8859-1");
            StringTokenizer st = new StringTokenizer(strKeywordUsed);
            String strKeywordUsedToken="";
            int intCount=0;
            while (st.hasMoreTokens()) {
                strKeywordUsedToken=st.nextToken().trim();
    	 	    intTokenLen=strKeywordUsedToken.length();
    	 	    int intSearchStart=0;
    	 	    while (intSearchStart<intLen) {
    	 	        intIndex=s.indexOf(strKeywordUsedToken,intSearchStart);
    	 	        if (intIndex<0){
    	 	            break;
    	 	           }
    	 	        intStart=intIndex;
    	 	        intEnd=intIndex+intTokenLen;
    	 	        for (int i=0; i<50; i++) {
    	 	    	    if (intStart<=0)
    	 	    	        break;
    	 	    		intStart--;

    	 	        }
    	 	        for (int i=0; i<30; i++) {
    	 	    	    if (intEnd>=intLen)
    	 	    	        break;
    	 	    		intEnd++;
    	 	        }

    	 	        if (intStart>0) {
    	 	            while ((intStart<intLen)&&(byteContent[intStart-1]!=(byte)(' '))) {
    	 	        	    intStart++;
    	 	            }
    	 	        }
    	 	        if (intEnd<intLen) {
    	 	            while ((intEnd>intIndex+intTokenLen)&&(byteContent[intEnd]!=(byte)(' '))) {
    	 	                intEnd--;
    	 	            }
    	 	        }
    	 	       /* strReturn+="... "+strContent.substring(intStart,intIndex)+"<font color=CC0033>"+strKeywordUsedToken+"</font>";
       	 	        if(((intIndex+intTokenLen)<intLen)&&(intIndex+intTokenLen)<intEnd){
    	 	           strReturn+=strContent.substring(intIndex+intTokenLen,intEnd);
    	 	        }*/
    	 	        if ((intEnd<=intLen)&&(intStart>=0)) {
    	 	        	strReturn+="..."+strContent.substring(intStart,intEnd);
    	 	        	intCount++;
    	 	        	if (intCount>=5) {
    	 	        		break;
    	 	        	}
    	 	        }
    	 	        intSearchStart=intIndex+intTokenLen;
    	 	     }
   	    	     strReturn=highlightString(strReturn,strKeywordUsedToken);
   	    	     if (intCount>=5) {
   	    	     	break;
   	    	     }
            }
            //if (strReturn.length()>600)
            //    strReturn=strReturn.substring(0,600);
            strReturn=formatAbstract(strReturn)+" ...";
        }
        catch (Exception e) {
        	System.out.println("Error getAbstract intStart "+intStart+" intIndex "+intIndex+" intEnd "+intEnd+" intLen "+intLen+" intIndex+intTokenLen"+(intIndex+intTokenLen));
        }

        return strReturn;
	 /*
	 	if ((intLen<0)||(intLen>300))
	 	    intLen=300;
	 	try {
	 	    intEnd=strContent.indexOf("\n\n");
	 		if (intEnd>intLen)
	 		    intEnd=intLen;
	 		if (intEnd<10)
	 		    intEnd=10;
            byte [] byteContent=strContent.getBytes("ISO-8859-1");
          	strTopOfContent=new String (byteContent,0,intEnd);
	    	strTopOfContent=htmlFormat (strTopOfContent);
	 	}
	 	catch (Exception e) {
	 	}
	 	*/
    }
	 private String formatAbstract(String s) {
 	    String strReturn="";
 	    int intStart=0, intEnd=0;

	 	try {
	 		byte [] byteAbstract=s.getBytes("ISO-8859-1");
	 		int intLen=byteAbstract.length;
	 		boolean blnTag=false;
	 	    for (int i=0; i<intLen;i++) {

	 		    if (((i%130)==0)&&(i>0)){
	 			    intEnd=i;
	 			    if (blnTag==true) {
	 			        while ((intEnd>1)&&(byteAbstract[intEnd]!=(byte)('<'))) {
    	 				    intEnd--;
	     			    }
	 			    	if (intEnd>0)
	 			    	   intEnd--;
	     			 }
	     			 else {
	     			     while ((intEnd>1)&&(byteAbstract[intEnd]!=(byte)(' '))) {
    	 				     intEnd--;
	     			     }
	     			 }


	 	    		strReturn+=new String(byteAbstract, intStart,intEnd-intStart+1)+"<br>";
	 		    	intStart=intEnd+1;

	 		    }
	 	    	if (byteAbstract[i]==(byte)'<'){
	 	    	    blnTag=true;
	 	    	}
	 	    	if (byteAbstract[i]==(byte)'>')
	 	    	    blnTag=false;
	 	    }
	 	    strReturn+=s.substring(intStart);
	     }
	     catch (Exception e) {
	     	System.out.println("Error formatAbstract intStart "+intStart+" intEnd "+intEnd+e.getMessage());

	     }
	     return strReturn;
	   }
	 public String replaceString(String strInput, String p,String q) {
	 	String s=strInput.toLowerCase();
	 	String strReturn="",strBegin="",strEnd="";
	 	int intLen=s.length();
	 	int intIndex=0;
	 	do {
	 		intIndex=s.indexOf(p,intIndex);
	 		if (intIndex<0)
	 		    break;
	 		if (intIndex>0)
	 		    strBegin=strInput.substring(0,intIndex);
        	strEnd=strInput.substring(intIndex+p.length());
	 		strInput=strBegin+q+strEnd;
	 		s=strInput.toLowerCase();
	 		intIndex+=q.length();

	 	}
	 	while (intIndex<intLen);
	 	return strInput;
	 }
	 public String highlightString(String s, String strKeyword) {
	 	try {
	 		//s=s.toLowerCase();
	 		StringTokenizer st = new StringTokenizer(strKeyword);
	 		String strKeywordUsedToken="";
            while (st.hasMoreTokens()) {
                strKeywordUsedToken=st.nextToken().trim();
                s=replaceString(s,strKeywordUsedToken,"<font color=CC0033> "+strKeywordUsedToken+"</font>");
            }
	     }
	     catch (Exception e) {
	     	System.out.println("Error highlightString"+e.getMessage());
	     }
	     return s;
	   }

	 public static String htmlFormat(String strContent) throws IOException{
	    byte[] byteContent=strContent.getBytes("ISO-8859-1");
	    int intLen=byteContent.length;
	    byte[] byteHtml= new byte[intLen*2+4];
	    int intIndex=0;
	    try {
	        for (int i=0; i<intLen; i++) {
	    	    if ((byteContent[i]==10)||(byteContent[i]==13)) {
	    		    byteHtml[intIndex]=(byte)'<';
	    		    byteHtml[intIndex+1]=(byte)'b';
	    		    byteHtml[intIndex+2]=(byte)'r';
	    		    byteHtml[intIndex+3]=(byte)'>';
	    		    intIndex+=4; //4: length of <br>
	    	    }
	    	    else {
    	    	    byteHtml[intIndex]=byteContent[i];
	        	    intIndex++;
	        	}
	        }
	     }
	     catch (Exception e) {
	     }
	     String strResult=new String(byteHtml,0,intIndex);
	     return strResult;
	 }
 	public String Stemming(String strTerm){
		return st.stripAffixes(strTerm);
	}

	public double getRank(int intDocID) {
		return ((Double)SearchResult.get(new Integer(intDocID))).doubleValue();
	}

	/*public HashMap getDocVector(int intDocID) {
		HashMap termWeightVector=new HashMap();
		try {
		    String strVector = getWeightVector(intDocID);
		    byte[] byteVector=strVector.getBytes();
		    int intLen=strVector.length();

		    int intIndex=0, intStart=0;
    	    while (intIndex<intLen){
    	    	if (byteVector[intIndex]==(byte)(' ')) {
    	    		String strTerm= new String(byteVector,intStart,intIndex-intStart-3);
                //byte[] byteWeight=new byte[3];
                //byteWeight[0]=byteVector[intEnd-2];
                //byteWeight[1]=byteVector[intEnd-1];
                //byteWeight[2]=byteVector[intEnd];
                //int intWeight=new java.math.BigInteger(byteWeight).intValue();
                //dblWeight=(double)intWeight/10000000.0;
                                termWeightVector.put(strTerm,strTerm);
                System.out.println(strTerm);
    	    	intStart=intIndex+1;



    	    	}
    	    	intIndex++;

		        //String strTermWeight = st.nextToken();
		        //int intTermWeightLen=strTermWeight.length();
		        //String strTerm=strTermWeight.substring(0,intTermWeightLen-3);
                //byte[] byteWeight=new byte[3];
                //byteWeight[0]=byteVector[intEnd-2];
                //byteWeight[1]=byteVector[intEnd-1];
                //byteWeight[2]=byteVector[intEnd];
                //int intWeight=new java.math.BigInteger(byteWeight).intValue();
                //dblWeight=(double)intWeight/10000000.0;
                System.out.println("intStart "+intStart+" intIndex "+intIndex+" intLen "+intLen);
    		}
	    }
	    catch (Exception e) {
	    	System.out.println("Error getDocVector "+e.getMessage());
	    }
		return termWeightVector;
	}*/

	public double getDocSimilarity(int intDocIDFirst, int intDocIDSecond) {
		double dblSimilarity=0.0;
		try {
            HashMap m1=getHashMapWeight(intDocIDFirst);
            HashMap m2=getHashMapWeight(intDocIDSecond);
            String strTerm="";
   	        Set setWeightVector = m1.entrySet();
   	        //iterate through mappings and print content
            for (Iterator i = setWeightVector.iterator(); i.hasNext();) {
    	        Map.Entry weightVectorEntry = (Map.Entry)i.next();
        		strTerm=(String)weightVectorEntry.getKey();
        		double dblWeightFirst=((Double)weightVectorEntry.getValue()).doubleValue();
        		if (m2.containsKey(strTerm)) {
        			double dblWeightSecond=((Double)m2.get(strTerm)).doubleValue();
        			dblSimilarity+=dblWeightFirst*dblWeightSecond;
        	    }
            }
        }
        catch (Exception e) {
        	System.out.println("Error getDocSimilarity "+ e.getMessage());
        }
		return dblSimilarity;
	}
	public HashMap getHashMapWeight(int intDocID){
		HashMap weightHashMap=new HashMap();
		int intLen=0;
		double dblWeight=0.0;
		try {
		    String strVector = getWeightVector(intDocID);
		    byte[] byteVector=strVector.getBytes();

		    intLen=strVector.length();
		    int intLoop=(intLen-intLen%6)/6;

    	    for (int i=0;i<intLoop;i++) {
            	byte[] byteNo= new byte[3];
          		byteNo[0]=byteVector[i*6];
      	    	byteNo[1]=byteVector[i*6+1];
      		    byteNo[2]=byteVector[i*6+2];
        	    String strNo=new String(byteNo);
                byte[] byteWeight=new byte[3];
                byteWeight[0]=byteVector[i*6+3];
                byteWeight[1]=byteVector[i*6+4];
                byteWeight[2]=byteVector[i*6+5];
                int intWeight=new java.math.BigInteger(byteWeight).intValue();
                dblWeight=((double)intWeight)/10000000.0;
                weightHashMap.put(strNo,new Double(dblWeight));
    	    }
	    }
	    catch (Exception e) {
	    	//System.out.println("intStart "+intStart+" intIndex "+intIndex+" intLen "+intLen);
	    	System.out.println("Error getHashMapWeight "+e.getMessage());
	    }
		return weightHashMap;

	}

	public String getVector(int intDocID){

    	IRZIP zip=new IRZIP();
    	String strVector="";
    	try {
		    strVector =zip.uncompress((String) vectorDatabase.fetch(Integer.toString(intDocID)));
		}
		catch (Exception e) {
			System.out.println("Error getVector "+e.getMessage());
	    }
	    return strVector;
	}
	public String getWeightVector(int intDocID){

    	String strVector="";
    	try {
		    strVector =(String)weightDatabase.fetch(Integer.toString(intDocID));
		}
		catch (Exception e) {
			System.out.println("Error getWeightVector "+e.getMessage());
	    }
	    return strVector;
	}

/*	public int compare (byte[] s, byte[] d) throws IOException {
		int intSLen=s.length, intDLen=d.length,i=0;
		for (i=0;((i<intSLen)&&(i<intDLen));i++) {
			if ((char)s[i]>(char)d[i]) {
			    return 1;
			}
			else {
				if (s[i]<d[i]) {
					return -1;
				}
		    }
		}
		if (intSLen==intDLen)
			return 0;
		if (intSLen>intDLen)
			return 1;
	    else
	        return -1;

	}
	*/
	/*static public boolean compare(byte[] s, byte[] d) {
		boolean blnEqual=false;
		int intLen=s.length;
        if (intLen!=d.length) {
            return false;
        }

        for (int i=0; i<intLen; i++) {
            if (s[i]!=d[i]){
            	return false;
            }
        }
        return true;
	}*/
	public double getWeight(String strKeyword,String strVector){
		double dblWeight=0.0;
		byte[] byteKeyword=strKeyword.getBytes();
		byte[] byteVector=strVector.getBytes();
        int intLen=strVector.length();
        int intLoop=(intLen-intLen%6)/6;
        int low=0, high=intLoop-1, mid=0;
		try {
            while (low<=high){
        	mid=low+high;
        	mid=(mid-mid%2)/2; //mid index in the sublist

        	byte[] byteNo= new byte[3];
      		byteNo[0]=byteVector[mid*6];
      		byteNo[1]=byteVector[mid*6+1];
      		byteNo[2]=byteVector[mid*6+2];
        	String strNo=new String(byteNo);
        	//int intCompare=compare(byteNo,byteKeyword);
            int intCompare=strNo.compareTo(strKeyword);

        	if (intCompare==0){
        		// have a match.
                byte[] byteWeight=new byte[3];
                byteWeight[0]=byteVector[mid*6+3];
                byteWeight[1]=byteVector[mid*6+4];
                byteWeight[2]=byteVector[mid*6+5];
                int intWeight=new java.math.BigInteger(byteWeight).intValue();
                dblWeight=((double)intWeight)/10000000.0;
                return dblWeight;
		    }
    	    if (intCompare>0)
                high=mid-1; //go to upper sublist
            else
                 low=mid+1;
		 }
        return dblWeight;
    }
    catch (Exception e) {
    	System.out.println("Error getWeight "+e.getMessage());
    }
    return dblWeight;

	}



}